# Pressure Stall Information (PSI) - Alerts 
## PURPOSE

This project aims to deliver Pressure Stall Information (PSI) alerts via
standard Linux graphical desktop (through `libnotify` compatible daemons and
CLI programs), and email (email-to-SMS is also supported).  This can alert the
system administrator of CPU, I/O, or Memory (RAM) pressure in near real time.

## PREREQUISITES
* A Linux system with kernel 5.2.0 or greater
* systemd
* zsh
* ssh (OpenSSH, for desktop notifications)
* psi-by-example (a modified version of this is included in this project as a
  submodule)

## INSTALL
First, clone this repository with the `--recurse-submodules` flag:
```
$ git clone --recurse-submodules https://git.eldon.me/trey/psi-alerts.git
```

## CONFIGURE
Included in this project are a number of systemd units:
    * psi-monitor.service
    * psi-alerts@.service (template service)

## TODO
* finish INSTALL section
    * figure out how we're actually going to build all submodules
    * and install them
* finish CONFIGURE section
    * about defining an instance and editing it
        * `sudo systemctl edit psi-alerts@<user>.service`
        * mainly for `Environment=` variables
